% This file makes Figure II - model residuals across the ergodic set
% conditional on no realized disasters.
% To run this file, you first have to run accuracy_and_simulation.m for all
% solutions for model version 8, and present_tables.m for the same version.

clear,clc, close all
load('models')

model_no=8;

veri='1'; % choose disaster parameterization
load(['present_no_disasters_ver' veri '_' models{model_no}])

set(0, 'defaultFigurePaperPosition',  [0 0 20 21.5]);

fig= figure('color', [1 1 1], 'PaperType', 'A4');
% T=size(tp2_r,2);
T=1000;

limits2=[1,T,-.04,.04];
limits3=[1,T,-8e-3,8e-3];

range=9001:10000;
limits2=[1,1000,-.04,.04];
limits3=[1,1000,-8e-3,8e-3];

subplot(3,2,1)
plot(pert4_r(:,range)');
title('Perturbation 4th order')

axis(limits2) 

subplot(3,2,2)
plot(pert5_r(:,range)');
title('Perturbation 5th order')
axis(limits2) 

subplot(3,2,5)
plot(tp2_r(:,range)');
title('Taylor Projection 2nd order')

axis(limits2) 

subplot(3,2,6)
plot(tp3_r(:,range)');
title('           Taylor Projection 3rd order')
axis(limits3) 

subplot(3,2,3)
plot(smol2_r(:,range)');
title('Smolyak 2nd order')
axis(limits2) 

subplot(3,2,4)
plot(smol3_r(:,range)');
title('Smolyak 3rd order')
axis(limits3) 

saveas(fig,['newEE8_no_disasters.eps'],'epsc')
