% This file presents the results

clear,clc, close all
load('models')
models=models(end); % take a specific model
main_folder=pwd;

all_versions=[1]; % do disaster parameterizaion
% all_versions=[0]; % do no-disaster parameterization
% all_versions=[0,1]; % do both
% all_versions=[2,3,4]; % do robustness tests

% all solutions:
names={'pert1','pert2','pert3','pert4','pert5','tp1','tp2','tp3','smol1','smol2','smol3'};

% only cheap solutions

if exist('options.mat','file')~=0
    load('options');
else
    do_all_solutions=1;
end

if do_all_solutions==0
    names={'pert1','pert2','pert3','tp1','tp2','tp3','smol1','smol2'};
end

for veri=all_versions

    version=['ver' num2str(veri)];


    n_models=length(models);
    n_methods=length(names);
    smol3_grid_expansion=zeros(n_models,1);

    maxEE=zeros(n_models,n_methods);
    meanEE=zeros(n_models,n_methods);
    runtime=zeros(n_models,n_methods);
    RoE_mean=zeros(n_models,n_methods); 
    RoE_std=zeros(n_models,n_methods); 
    Rf_mean=zeros(n_models,n_methods); 
    Rf_std=zeros(n_models,n_methods); 
    tily_mean=zeros(n_models,n_methods);
    tilc_mean=zeros(n_models,n_methods);
    tilx_mean=zeros(n_models,n_methods);
    consumption_fall=zeros(n_models,n_methods);
    for modeli=1:length(models)

        load(['performance\' version '\' models{modeli} '\accuracy_no_disasters'],'pert*','tp*','smol*','shocks','T')

        % Euler Errors - max and mean
        t_start=100; t_end=T; % take a sample from t_start to t_end
%         t_start=1;t_end=10
        for j=1:n_methods
           eval(['solution=' names{j} '_r;'])
           maxEE(modeli,j)=max(log10(max(abs(solution(:,t_start:t_end)))));
           if ~isreal(maxEE(modeli,j))
               maxEE(modeli,j)=Inf;
           end
           meanEE(modeli,j)=mean(log10(max(abs(solution(:,t_start:t_end))))); % mean across simulation points of max error across equations.
           if ~isreal(meanEE(modeli,j))
               meanEE(modeli,j)=Inf;
           end
        end

        % runtime
        for i=1:length(names)
            eval(['runtime(modeli,i)=' names{i} '_time;']);
        end

        % Simulation moments

%         load([main_folder '\performance\' version '\' models{modeli} '\simulation'],'results_*','x_tp*','x_pert*','x_smol*','nu_*')
% 
%         for i=1:length(names)
%             load([main_folder '\files_for_smolyak\' models{modeli} '\order1\model'],'subsvars','y','x')
%             eval(['results=results_' names{i} '(:,t_start:t_end);'])
%             eval(['x_simul=x_' names{i} '(:,t_start:t_end);'])
%             eval(['nu=nu_' names{i} '(:,t_start:t_end);'])
% 
%             tildiv=nu(logical(subsvars==sym('tildiv')),:);
%             loghatz=nu(logical(subsvars==sym('loghatz')),:);
%             logtilqe=results(logical(y==sym('logtilqe')),:);
%             logqf=results(logical(y==sym('logqf')),:);
%             logtheta=x_simul(logical(x==sym('logtheta')),:);
%             logtilxback=x_simul(logical(x==sym('logtilxback')),:);
%             
%             tily=nu(logical(subsvars==sym('tily')),:);
%             tilc=nu(logical(subsvars==sym('tilc')),:);
%             tilx=nu(logical(subsvars==sym('tilx')),:);
%             logtilk=nu(logical(subsvars==sym('logtilk')),:);
%             tilk=exp(logtilk);
% 
%             RoE=exp(loghatz(2:end)).*(tildiv(2:end)+exp(logtilqe(2:end))).*exp(-logtilqe(1:end-1));
%             RoE=100*(RoE.^4-1); %annualized
%             Rf=exp(-logqf);
%             Rf=100*(Rf.^4-1);%annualized
%             RoE_mean(modeli,i)=mean(RoE);
%             if ~isreal(RoE_mean(modeli,i))
%                 RoE_mean(modeli,i)=Inf;
%             end
%             RoE_std(modeli,i)=std(RoE);
%             Rf_mean(modeli,i)=mean(Rf);
%             if ~isreal(Rf_mean(modeli,i))
%                 Rf_mean(modeli,i)=Inf;
%             end
%             Rf_std(modeli,i)=std(Rf);
%             
%             tily_mean(modeli,i)=mean(tily);
%             tilc_mean(modeli,i)=mean(tilc);
%             tilx_mean(modeli,i)=mean(tilx);
%             tilk_mean(modeli,i)=mean(tilk);
%             
%             tily_std(modeli,i)=std(tily);
%             tilc_std(modeli,i)=std(tilc);
%             tilx_std(modeli,i)=std(tilx);
%             tilk_std(modeli,i)=std(tilk);
% 
%         end
        
        save(['present_no_disasters_' version '_' models{modeli}])
    end
    % present tables
    if veri==0
%         disp('no-disaster parametrization')
%         disp(names)
%         meanEE
%         disp(names)
%         maxEE
    elseif veri==1
        disp('disaster parametrization')
        disp(names)
        meanEE
        disp(names)
        maxEE
%         disp(names)
%         Rf_mean
%         disp(names)
%         RoE_mean
%         disp(names)
%         tilx_mean
%         disp(names)
%         tilk_mean
%         disp(names)
%         tilx_std
%         disp(names)
%         tilk_std
%         disp(names)
%         runtime
    else
%         disp('runtime')
%         runtime
%         disp(names)
%         meanEE
%         disp(names)
%         maxEE
%         disp(names)
%         Rf_mean
%         disp(names)
%         RoE_mean        
    end

end


