% This file presents the results

clear,clc, close all
load('models')
% models=models(2); % take a specific model
main_folder=pwd;

all_versions=[1];

% all solutions:
names={'tp1','tp2','tp3'};

% only cheap solutions

if exist('options.mat','file')~=0
    load('options');
else
    do_all_solutions=1;
end

if do_all_solutions==0
    names={'tp1','tp2','tp3'};
end

for veri=all_versions

    version=['ver' num2str(veri)];


    n_models=length(models);
    n_methods=length(names);
    smol3_grid_expansion=zeros(n_models,1);

    maxEE=zeros(n_models,n_methods);
    meanEE=zeros(n_models,n_methods);
    distance=zeros(n_models,n_methods);
    for modeli=1:length(models)

        load(['performance\' version '\' models{modeli} '\accuracy_and_runtime_stochastic_ss'],'tp*','shocks','T')
        load([main_folder '\' tp_folder '\' models{modeli} '\order1\solution_tp_stochastic_ss'],'nxss','nxss_stochastic');
        % Euler Errors - max and mean
        t_start=100; t_end=T; % take a sample from t_start to t_end
        for j=1:n_methods
           eval(['solution=' names{j} '_r;'])
           maxEE(modeli,j)=max(log10(max(abs(solution(:,t_start:t_end)))));
           if ~isreal(maxEE(modeli,j))
               maxEE(modeli,j)=Inf;
           end
           meanEE(modeli,j)=mean(log10(max(abs(solution(:,t_start:t_end))))); % mean across simulation points of max error across equations.
           if ~isreal(meanEE(modeli,j))
               meanEE(modeli,j)=Inf;
           end
           distance(modeli,j)=norm(nxss-nxss_stochastic);
        end
        clearvars pert* tp* smol*
    end
    % present tables
    if veri==1
        disp('disaster parametrization')
        disp(names)
        meanEE
        disp(names)
        maxEE
    end

end


